// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'LogError.pas' rev: 5.00

#ifndef LogErrorHPP
#define LogErrorHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <LogBase.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Logerror
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TSMLAOption { laShowSendEMail, laShowSupportLink };
#pragma option pop

typedef Set<TSMLAOption, laShowSendEMail, laShowSupportLink>  TSMLAOptions;

#pragma option push -b-
enum TSMLErrorDialog { edNone, edStandard, edExtended };
#pragma option pop

#pragma option push -b-
enum TSMLFormat { lfDate, lfTime, lfPhysAddress, lfMessage, lfSeparator };
#pragma option pop

typedef Set<TSMLFormat, lfDate, lfSeparator>  TSMLFormats;

#pragma option push -b-
enum TSMExceptionStandard { efAbort, efOutOfMemory, efInOutError, efIntError, efDivByZero, efRangeError, 
	efIntOverflow, efMathError, efInvalidOp, efZeroDivide, efOverflow, efUnderflow, efInvalidPointer, efInvalidCast, 
	efConvertError, efAccessViolation, efPrivilege, efStackOverflow, efControlC, efVariantError, efPropReadOnly, 
	efPropWriteOnly, efExternalException, efAssertionFailed, efAbstractError, efIntfCastError, efInvalidContainer, 
	efInvalidInsert, efPackageError, efWin32Error };
#pragma option pop

typedef Set<TSMExceptionStandard, efAbort, efWin32Error>  TSMExceptionStandards;

#pragma option push -b-
enum TSMExceptionClass { efStreamError, efFCreateError, efFOpenError, efFilerError, efReadError, efWriteError, 
	efClassNotFound, efMethodNotFound, efInvalidImage, efResNotFound, efListError, efBitsError, efStringListError, 
	efComponentError, efParserError, efOutOfResources, efInvalidOperation, efThread };
#pragma option pop

typedef Set<TSMExceptionClass, efStreamError, efThread>  TSMExceptionClasses;

#pragma option push -b-
enum TSMExceptionGraphic { efInvalidGraphic, efInvalidGraphicOperation };
#pragma option pop

typedef Set<TSMExceptionGraphic, efInvalidGraphic, efInvalidGraphicOperation>  TSMExceptionGraphics;
	

typedef void __fastcall (__closure *TSMLSaveExceptionEvent)(System::TObject* Sender, Sysutils::Exception* 
	E, AnsiString &LogText, bool &Accept);

class DELPHICLASS TSMExceptionLog;
class PASCALIMPLEMENTATION TSMExceptionLog : public Logbase::TSMLogBase 
{
	typedef Logbase::TSMLogBase inherited;
	
private:
	Forms::TExceptionEvent FoldOnException;
	Forms::TExceptionEvent FOnException;
	TSMLSaveExceptionEvent FOnSaveException;
	TSMLErrorDialog FErrorDialog;
	TSMExceptionStandards FFilterStandard;
	TSMExceptionClasses FFilterClasses;
	TSMExceptionGraphics FFilterGraphics;
	TSMLFormats FFormats;
	TSMLAOptions FOptions;
	void __fastcall ActiveWeb(System::TObject* Sender);
	void __fastcall ActivateMail(System::TObject* Sender, bool IncludeScreenshot);
	
protected:
	void __fastcall DoException(System::TObject* Sender, Sysutils::Exception* E);
	
public:
	__fastcall virtual TSMExceptionLog(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMExceptionLog(void);
	
__published:
	__property TSMLErrorDialog ErrorDialog = {read=FErrorDialog, write=FErrorDialog, default=2};
	__property TSMExceptionStandards FilterStandard = {read=FFilterStandard, write=FFilterStandard, default=1073741823
		};
	__property TSMExceptionClasses FilterClasses = {read=FFilterClasses, write=FFilterClasses, default=262143
		};
	__property TSMExceptionGraphics FilterGraphics = {read=FFilterGraphics, write=FFilterGraphics, default=3
		};
	__property TSMLFormats Formats = {read=FFormats, write=FFormats, default=31};
	__property TSMLAOptions Options = {read=FOptions, write=FOptions, default=3};
	__property Forms::TExceptionEvent OnException = {read=FOnException, write=FOnException};
	__property TSMLSaveExceptionEvent OnSaveException = {read=FOnSaveException, write=FOnSaveException}
		;
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Logerror */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Logerror;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// LogError
